import * as React from 'react';
import { FieldValues, FieldName, Control, FieldPath, FieldError } from './';
import { RegisterOptions } from './validator';
export declare type ControllerMeta = {
    invalid: boolean;
    isTouched: boolean;
    isDirty: boolean;
    isValidating: boolean;
    error: FieldError;
};
export declare type ControllerRenderProps<TFieldValues extends FieldValues = FieldValues> = {
    onChange: (...event: any[]) => void;
    onBlur: () => void;
    value: any;
    name: FieldName<Control<TFieldValues>>;
    ref: React.Ref<any>;
};
export declare type UseControllerProps<TFieldValues extends FieldValues = FieldValues> = {
    name: FieldPath<TFieldValues>;
    rules?: Exclude<RegisterOptions, 'valueAsNumber' | 'valueAsDate' | 'setValueAs'>;
    defaultValue?: unknown;
    control?: Control<TFieldValues>;
};
export declare type UseControllerReturn<TFieldValues extends FieldValues = FieldValues> = {
    field: ControllerRenderProps<TFieldValues>;
    meta: ControllerMeta;
};
export declare type ControllerProps<TFieldValues extends FieldValues = FieldValues> = {
    render: ({ field, meta, }: {
        field: ControllerRenderProps<TFieldValues>;
        meta: ControllerMeta;
    }) => React.ReactElement;
} & UseControllerProps<TFieldValues>;
